#include <stdio.h>
#include <string.h>

#include "strat.hpp"


void cat_decision(char *buf, float *texps, int splitmode) {

  if (splitmode) {
    if (texps[3] > texps[2] && texps[3] > texps[1] && texps[3] > texps[0]) {
      strcat(buf, "  Y ");
    } else {
      strcat(buf, "  N ");
    }
  } else {
    if (texps[2] > texps[1] && texps[2] > texps[0]) {
      if (texps[0] > texps[1]) strcat(buf, " Ds ");
      else strcat(buf, " Dh ");
    } else {
      if (texps[1] > texps[0]) strcat(buf, "  H ");
      else strcat(buf, "  S ");
    }
  }
}

void build_chart(strat *s, char *buf) {

  int hard_decs[10*10];
  float hard_exps[10*10];
  float texps[4];
  int i,j;
  int comparse = 0;
  char tbuf[200];

  strcpy(buf, "");

  sprintf(tbuf, "%s%s     2   3   4   5   6   7   8   9  10   A\n%s------------------------------------------\n",
          comparse ? "start hard\n" : "", comparse ? "#" : " ", comparse ? "#" : "-");
  strcat(buf, tbuf);

  for (i=17; i>=8; i--) {
    sprintf(tbuf, "%2d: ", i);
    strcat(buf, tbuf);

    for (j=0; j<10; j++) {
      if (i>12) s->decide(&texps[0], i-9, 9, j==9 ? 1 : j+2);
      else s->decide(&texps[0], i-6, 6, j==9 ? 1 : j+2);

      cat_decision(buf, texps, 0);
    }
    strcat(buf, "\n");
  }
  if (comparse) {
    sprintf(tbuf, "end\n");
    strcat(buf, tbuf);
  }

  strcat(buf, "\n\n");

  sprintf(tbuf, "%s%s     2   3   4   5   6   7   8   9  10   A\n%s------------------------------------------\n",
          comparse ? "start soft\n" : "", comparse ? "#" : " ", comparse ? "#" : "-");
  strcat(buf, tbuf);
  for (i=9; i>=2; i--) {
    sprintf(tbuf, "A,%d:", i);
    strcat(buf, tbuf);
    for (j=0; j<10; j++) {
      s->decide(&texps[0], i, 1, j==9 ? 1 : j+2);

      cat_decision(buf, texps, 0);
    }
    strcat(buf, "\n");
  }
  if (comparse) {
    sprintf(tbuf, "end\n");
    strcat(buf, tbuf);
  }

  strcat(buf, "\n\n");

  sprintf(tbuf, "%s%s     2   3   4   5   6   7   8   9  10   A\n%s------------------------------------------\n",
          comparse ? "start split\n" : "", comparse ? "#" : " ", comparse ? "#" : "-");
  strcat(buf, tbuf);
  for (i=11; i>=2; i--) {
    if (i == 11) sprintf(tbuf, " A: ", i);
    else sprintf(tbuf, "%2d: ", i);
    strcat(buf, tbuf);

    for (j=0; j<10; j++) {
      s->decide(&texps[0], i==11 ? 1 : i, i==11 ? 1 : i, j==9 ? 1 : j+2);

      cat_decision(buf, texps, 1);
    }
    strcat(buf, "\n");
  }
  if (comparse) {
    sprintf(tbuf, "end\n");
    strcat(buf, tbuf);
  }

}

void print_chart(strat *s) {

  char buf[2048];

  build_chart(s, buf);
  printf("%s\n", buf);

}
