#define RULE_DAS 1
#define RULE_H17 2
#define RULE_RSA 4

#define ACTION_HIT 1
#define ACTION_STAND 2
#define ACTION_DOUBLE 4
#define ACTION_SPLIT 8



class hand {

public:
  hand();
  hand(int a);
  hand(int a, int b);

  void addcard(int val);
  void changelast(int val);
  void remlast();

  int handval();
  int issoft();
  int num();
  int single(int position);

private:
  inline void update();
  int i_h[21];
  int i_num, i_handval, i_issoft;
  int needsupdate;

};





class strat {

public:
  strat(int numdecks, int rules, int maxsplits);

  void decide(float *expect, int a, int b, int up);
  int insurance_decide();

  void dealer_probs(float *probs, hand *dh);
  void hit_probs(float probmult, float *probs, float *resprobs, hand *th, hand *dh);
  void stand_probs(float probmult, float *probs, float *resprobs, hand *th, hand *dh);
  void double_probs(float probmult, float *probs, float *resprobs, hand *th, hand *dh);
  void split_probs(float probmult, float *probs, float *resprobs, hand *th, hand *dh);

  void shoe_reset(int numdecks);
  inline void shoe_remove(int value);
  inline void shoe_add(int value);
  inline float prob(int value);

private:
  int rules;
  int maxsplits;
  int currsplit;

  int cards[11];
  int numcards;

  void decide_aux(float probmult, int allow, float *expect, hand *th, hand *dh);
  void dealer_probs_aux(float probmult, float *probs, hand *th);


};
